'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function knuthShuffle(nodes, _start = 0, _end = nodes.length) {
    const start = Math.max(0, _start);
    const end = Math.min(nodes.length, _end);
    if (start + 1 >= end)
        return;
    const N = end - start;
    for (let n = N - 1, i, j = end - 1, x; n > 0; --n, --j) {
        i = randomInt(n) + start;
        x = nodes[i];
        nodes[i] = nodes[j];
        nodes[j] = x;
    }
}
function randomInt(n) {
    const x = (Math.random() * n) >> 0;
    return x === n ? n - 1 : x;
}

exports['default'] = knuthShuffle;
exports.knuthShuffle = knuthShuffle;
exports.randomInt = randomInt;
